% Get mean and variance for proposal by Newton method
% nstatus values: 
    % 0 - Newton converged
    % 1 - Nan somewhere
    % 2 - tolerance has not been reached after MaxIter Newton iterations


function [nstatus, x, H, f] = NewtonMethod(x0, FunDerivatives, tolerance, MaxIter, posInd)

x = x0;
nstatus = 2; %initial status
%H = []; return;
[f, J, H] = FunDerivatives(x);
H = Negadefinize(H);
% f
% x'
% J'
for newtiter = 1:MaxIter
    
    if any(isnan(H))
        nstatus = 1;
        break; 
    end
 %   if min(eig(-H))<0 % 
        
 %   end
     try
        v = H\J;
     catch
          nstatus = 1;
          break; 
     end
     
    if sum(abs(v)) < tolerance 
       nstatus = 0;
       break; 
    end
    %x = x - NewtonStep(x,v)*v;
    
    %for positive variables: 
    
    v(posInd:end,1) = min(x(posInd:end,1),v(posInd:end,1));
    
    x = x - (0.5./sqrt(newtiter)).*v;
    [f, J, H] = FunDerivatives(x);
    H = Negadefinize(H);
%    f
%    J
end
% f
% x'
% J'

